#version 400

in vec3 Vertex;
in vec3 Normal;
in vec2 TexCoords;

in vec3 Scale;
in mat4 TransformMatrix;

uniform mat4 ModelMatrix;
uniform mat4 ModelViewProjectionMatrix;

uniform vec4 ClipPlane = vec4(0.0, -1.0, 0.0, -5.0);

out vec3 VNormal;
out vec2 VTexCoords;

void main()
{
	VTexCoords = TexCoords;
	
	VNormal = normalize((ModelMatrix * TransformMatrix * vec4(Normal, 0.0)).xyz);
	
	vec4 vertex = ModelMatrix * TransformMatrix * vec4(Scale * Vertex, 1.0);
	gl_ClipDistance[0] = dot(vertex.xyz, ClipPlane.xyz) + ClipPlane.w;
	
	gl_Position = ModelViewProjectionMatrix * TransformMatrix * vec4(Scale * Vertex, 1.0);
}
