#version 400

in vec3 Vertex;
in vec3 Normal;

in mat4 Transform;
in vec3 Color;
in float Size;

uniform mat4 ViewMatrix;
uniform mat4 ProjectionMatrix;

uniform vec4 ClipPlane = vec4(0.0, -1.0, 0.0, -5.0);

out vec3 VNormal;
out vec3 VColor;

void main()
{
	VNormal = (Transform * vec4(Normal, 0.0)).xyz;
	VColor = Color;
	
	vec4 vertex = Transform * vec4(Vertex * Size, 1.0);
	gl_ClipDistance[0] = dot(vertex.xyz, ClipPlane.xyz) + ClipPlane.w;
	
	gl_Position = (ProjectionMatrix * ViewMatrix * Transform) * vec4(Vertex * Size, 1.0);
}
