#version 400

in vec2 Vertex;

uniform vec2 Origin;
uniform vec2 Scale;
uniform float Elevation;

uniform mat4 ModelViewProjectionMatrix;
uniform mat4 OtherModelViewProjectionMatrix;

out vec3 VWorldPosition;
out vec4 VPosition;
out vec4 OtherVPosition;

void main()
{
	vec3 vertex = vec3(Origin.x + Vertex.x * Scale.x, Elevation, Origin.y + Vertex.y * Scale.y);
	
	VWorldPosition = vertex;
	
	VPosition = ModelViewProjectionMatrix * vec4(vertex, 1.0);
	OtherVPosition = OtherModelViewProjectionMatrix * vec4(vertex, 1.0);
	
	gl_Position = ModelViewProjectionMatrix * vec4(vertex, 1.0);
}
